﻿//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SFWK.Core.CompositionAttribute
{
    public class CompositeBase : Attribute
    {
        /// <summary>
        /// Service interface -> contract
        /// </summary>
        public Type ServiceContract { get; set; }
        
        /// <summary>
        /// Search method for external base composition object only
        /// </summary>
        public string Search { get; set; }
        

        /// <summary>
        /// EF4/Internal object's constructor
        /// </summary>
        /// <param name="serviceContract"></param>
        public CompositeBase(Type serviceContract)
        {
            ServiceContract = serviceContract;
        }


        /// <summary>
        /// External base object's constructor
        /// </summary>
        /// <param name="serviceContract"></param>
        public CompositeBase(Type serviceContract, string search)
        {
            ServiceContract = serviceContract;
            Search = search;
        }
       
    }
}

