//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace SFWK.Core.ExpressionBuilder
{
    [Serializable]
    public class EditableElementInitCollection : List<EditableElementInit>
    {
        public EditableElementInitCollection() : base() { }
        public EditableElementInitCollection(IEnumerable<EditableElementInit> source) : base(source) { }
        public EditableElementInitCollection(IEnumerable<ElementInit> source) 
        {
            foreach (ElementInit ex in source)
                this.Add(new EditableElementInit(ex));
        }

        public IEnumerable<ElementInit> GetElementsInit()
        {
            foreach (EditableElementInit editEx in this)
                yield return editEx.ToElementInit();
        }       
    }
}

