//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace SFWK.Core.ExpressionBuilder
{
    public class EditableMemberInfoCollection : List<string>
    {
        public EditableMemberInfoCollection() : base() { }
        public EditableMemberInfoCollection(IEnumerable<string> source) : base(source) { }
        public EditableMemberInfoCollection(IEnumerable<MemberInfo> source) 
        {
            if (source != null)
            {
                foreach (MemberInfo ex in source)
                    this.Add(ex.ToSerializableForm());
            }
        }

        public IEnumerable<MemberInfo> GetMembers()
        {
            MemberInfo member = null;
            foreach (string editEx in this)
                yield return member.FromSerializableForm(editEx);
        }   
    }
}

