//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Linq.Expressions;
using System.Runtime.Serialization;

namespace SFWK.Core.ExpressionBuilder
{
    [DataContract]
    public class EditableConditionalExpression : EditableExpression
    {
        // Properties 
        [DataMember]
        public EditableExpression Test
        {
            get;
            set;
        }
        [DataMember]
        public EditableExpression IfTrue
        {
            get;
            set;
        }
        [DataMember]
        public EditableExpression IfFalse
        {
            get;
            set;
        }
         
        public override ExpressionType NodeType
        {
            get;
            set;
        }

        // Ctors
        public EditableConditionalExpression()
        {
        }

        public EditableConditionalExpression(ConditionalExpression condEx)
        {
            NodeType = condEx.NodeType;
            Test = EditableExpression.CreateEditableExpression(condEx.Test);
            IfTrue = EditableExpression.CreateEditableExpression(condEx.IfTrue);
            IfFalse = EditableExpression.CreateEditableExpression(condEx.IfFalse);
        }

        public EditableConditionalExpression(ExpressionType nodeType, EditableExpression test, EditableExpression ifTrue, EditableExpression ifFalse)
        {
            NodeType = nodeType;
            Test = test;
            IfTrue = ifTrue;
            IfFalse = ifFalse;
        }

        // Methods
        public override Expression ToExpression()
        {
            return Expression.Condition(Test.ToExpression(), IfTrue.ToExpression(), IfFalse.ToExpression());
        }
    }
}

