//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Linq.Expressions;
using System.Runtime.Serialization;
using System.Xml.Serialization;

namespace SFWK.Core.ExpressionBuilder
{
    [DataContract]
    public class EditableInvocationExpression : EditableExpression
    {
        // Properties
        [DataMember]
        public EditableExpression Expression
        {
            get;
            set;
        }

        [DataMember]
        public EditableExpressionCollection Arguments
        {
            get;
            set;
        }
    
        public override ExpressionType NodeType
        {
            get { return ExpressionType.Invoke; }
            set { }
        }

        // Ctors
        public EditableInvocationExpression()
        {
            Arguments = new EditableExpressionCollection();
        }

        public EditableInvocationExpression(InvocationExpression invocEx)
            : this()
        {
            Expression = EditableExpression.CreateEditableExpression(invocEx.Expression);
            foreach (Expression ex in invocEx.Arguments)
                Arguments.Add(EditableExpression.CreateEditableExpression(ex));
        }

        // Methods
        public override Expression ToExpression()
        {
            return System.Linq.Expressions.Expression.Invoke(Expression.ToExpression(), Arguments.GetExpressions());
        }
    }
}

