//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Linq.Expressions;
using System.Runtime.Serialization;
using System.Xml.Serialization;

namespace SFWK.Core.ExpressionBuilder
{
    [DataContract]
    public class EditableListInitExpression : EditableExpression
    {
        // Properties
        [DataMember]
        public EditableExpression NewExpression
        {
            get;
            set;
        }

        [DataMember]
        public EditableElementInitCollection Initializers
        {
            get;
            set;
        }
        
        public override ExpressionType NodeType
        {
            get { return ExpressionType.ListInit; }
            set { }
        }

        // Ctors
        public EditableListInitExpression()
        {
            Initializers = new EditableElementInitCollection();
        }

        public EditableListInitExpression(ListInitExpression listInit)
            : this()
        {
            NewExpression = EditableExpression.CreateEditableExpression(listInit.NewExpression);
            foreach (ElementInit e in listInit.Initializers)
            {
                Initializers.Add(new EditableElementInit(e));
            }
        }

        public EditableListInitExpression(EditableExpression newEx, IEnumerable<EditableElementInit> initializers)
        {
            Initializers = new EditableElementInitCollection(initializers);
            NewExpression = newEx;
        }

        // Methods
        public override Expression ToExpression()
        {
            return Expression.ListInit(NewExpression.ToExpression() as NewExpression, Initializers.GetElementsInit().ToArray<ElementInit>());
        }
    }
}

