//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Linq.Expressions;
using System.Reflection;
using System.Runtime.Serialization;
using System.Xml.Serialization;

namespace SFWK.Core.ExpressionBuilder
{
    [DataContract]
    public class EditableMemberExpression : EditableExpression
    {
        // Properties
        [XmlIgnore]
        public MemberInfo Member
        {
            get;
            set;
        }

        [DataMember]
        public EditableExpression Expression
        {
            get;
            set;
        }

        [DataMember]
        public string MemberName
        {
            get
            {
                return Member.ToSerializableForm();
            }
            set
            {
                Member = Member.FromSerializableForm(value);
            }
        }
        
        public override ExpressionType NodeType
        {
            get { return ExpressionType.MemberAccess; }
            set { }
        }

        // Ctors
        public EditableMemberExpression()
        {

        }

        public EditableMemberExpression(Expression rawEx, MemberInfo member)
            : this(EditableExpression.CreateEditableExpression(rawEx), member)
        { 
        }

        public EditableMemberExpression(EditableExpression editEx, MemberInfo member)
        {
            Member = member;
            Expression = editEx;
        }

        public EditableMemberExpression(MemberExpression membEx)
            : this(EditableExpression.CreateEditableExpression(membEx.Expression), membEx.Member)
        { 
        }

        // Methods
        public override Expression ToExpression()
        {
            Expression expression = null;
            if (Expression != null)
            {
                expression = Expression.ToExpression();
            }

            return System.Linq.Expressions.Expression.MakeMemberAccess(expression, Member);
        }
    }
}

