//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.Linq.Expressions;

namespace SFWK.Core.ExpressionBuilder
{
    [DataContract]
    public class EditableMemberMemberBinding : EditableMemberBinding
    {
        // Properties
        [DataMember]
        public EditableMemberBindingCollection Bindings 
        { 
            get; 
            set; 
        }

        public override MemberBindingType BindingType
        {
            get { return MemberBindingType.MemberBinding; }
            set { }
        }

        // Ctors
        public EditableMemberMemberBinding()
        {
        }

        public EditableMemberMemberBinding(MemberMemberBinding member) : base(member.BindingType, member.Member)
        {
            Bindings = new EditableMemberBindingCollection(member.Bindings);
        }

        // Methods
        public override MemberBinding ToMemberBinding()
        {
            return Expression.MemberBind(Member, Bindings.GetMemberBindings());
        }


    }
}

