//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SFWK.Core.Inspector
{
    /// <summary>
    /// Parameter inspector interface providing code injection for services
    /// </summary>
    public interface IInspect
    {
        /// <summary>
        /// Inspect the parameters
        /// </summary>
        /// <param name="operatorType">Type of operator passed</param>
        /// <param name="position">Position of the Operator parameter</param>
        /// <param name="operationName">Name of the method called</param>
        /// <param name="parameters">list of the method's parameters</param>
        void Inspect(SFWK.Core.Inspector.InspectorAttribute.EOperatorType operatorType, int position, string operationName, object[] parameters);

        /// <summary>
        /// Inspect the parameters
        /// </summary>
        /// <param name="operationName">Name of the method called</param>
        /// <param name="parameters">list of the method's parameters</param>
        void Inspect(string operationName, object[] parameters);
    }

    /// <summary>
    /// Parameter inspector interface providing code injection for services, befor call injection
    /// </summary>
    public interface IInspectAfterCall : IInspect
    {
        
    }

    /// <summary>
    /// Parameter inspector interface providing code injection for services, after call injection
    /// </summary>
    public interface IInspectBeforeCall : IInspect
    {
        
    }
}

