//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace SFWK.Core
{
    public static class ReflexionHelper
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="obj"></param>
        /// <param name="method"></param>
        /// <param name="parameter"></param>
        /// <returns></returns>
        public static bool HasMethod(object obj, string method, Type parameter)
        {
            foreach (MethodInfo m in obj.GetType().GetMethods().Where(m => m.Name == method))
                foreach (ParameterInfo param in m.GetParameters())
                    if (param.ParameterType == parameter)
                        return true;
            return false;
        }

        public static void InvokeMethod(object obj, string method, Type parameterType, object parameterValue)
        {
            foreach (MethodInfo m in obj.GetType().GetMethods().Where(m => m.Name == method))
                foreach (ParameterInfo param in m.GetParameters())
                    if (param.ParameterType == parameterType)
                    {
                        m.Invoke(obj, new object[]{parameterValue});
                        return;
                    }
        }

    }
}

