//------------------------------------------------------------------------------
//SFWK Framework
//Copyright (C) 2011 SQLI

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SFWK.Core
{
    /// <summary>
    /// Provides SFWK extenders
    /// </summary>
    public static class SFWKExtenders
    {
        /// <summary>
        /// Retruns true if value is null or equal to DateTime.MinValue, else false
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public static bool IsNullOrEmpty(this DateTime item)
        {
            return (item == null || item == DateTime.MinValue);
        }

        public static bool IsNullOrEmpty(this Guid? item)
        {
            return (item == null || item == Guid.Empty);
        }

    }
}

